// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/Accelerometer.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/accelerometer__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `name`
#include "rosidl_runtime_c/string_functions.h"

bool
rcss3d_agent_msgs__msg__Accelerometer__init(rcss3d_agent_msgs__msg__Accelerometer * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    rcss3d_agent_msgs__msg__Accelerometer__fini(msg);
    return false;
  }
  // x
  // y
  // z
  return true;
}

void
rcss3d_agent_msgs__msg__Accelerometer__fini(rcss3d_agent_msgs__msg__Accelerometer * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // x
  // y
  // z
}

bool
rcss3d_agent_msgs__msg__Accelerometer__are_equal(const rcss3d_agent_msgs__msg__Accelerometer * lhs, const rcss3d_agent_msgs__msg__Accelerometer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // x
  if (lhs->x != rhs->x) {
    return false;
  }
  // y
  if (lhs->y != rhs->y) {
    return false;
  }
  // z
  if (lhs->z != rhs->z) {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Accelerometer__copy(
  const rcss3d_agent_msgs__msg__Accelerometer * input,
  rcss3d_agent_msgs__msg__Accelerometer * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // x
  output->x = input->x;
  // y
  output->y = input->y;
  // z
  output->z = input->z;
  return true;
}

rcss3d_agent_msgs__msg__Accelerometer *
rcss3d_agent_msgs__msg__Accelerometer__create()
{
  rcss3d_agent_msgs__msg__Accelerometer * msg = (rcss3d_agent_msgs__msg__Accelerometer *)malloc(sizeof(rcss3d_agent_msgs__msg__Accelerometer));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__Accelerometer));
  bool success = rcss3d_agent_msgs__msg__Accelerometer__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__Accelerometer__destroy(rcss3d_agent_msgs__msg__Accelerometer * msg)
{
  if (msg) {
    rcss3d_agent_msgs__msg__Accelerometer__fini(msg);
  }
  free(msg);
}


bool
rcss3d_agent_msgs__msg__Accelerometer__Sequence__init(rcss3d_agent_msgs__msg__Accelerometer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcss3d_agent_msgs__msg__Accelerometer * data = NULL;
  if (size) {
    data = (rcss3d_agent_msgs__msg__Accelerometer *)calloc(size, sizeof(rcss3d_agent_msgs__msg__Accelerometer));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__Accelerometer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__Accelerometer__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__Accelerometer__Sequence__fini(rcss3d_agent_msgs__msg__Accelerometer__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__Accelerometer__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__Accelerometer__Sequence *
rcss3d_agent_msgs__msg__Accelerometer__Sequence__create(size_t size)
{
  rcss3d_agent_msgs__msg__Accelerometer__Sequence * array = (rcss3d_agent_msgs__msg__Accelerometer__Sequence *)malloc(sizeof(rcss3d_agent_msgs__msg__Accelerometer__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__Accelerometer__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__Accelerometer__Sequence__destroy(rcss3d_agent_msgs__msg__Accelerometer__Sequence * array)
{
  if (array) {
    rcss3d_agent_msgs__msg__Accelerometer__Sequence__fini(array);
  }
  free(array);
}

bool
rcss3d_agent_msgs__msg__Accelerometer__Sequence__are_equal(const rcss3d_agent_msgs__msg__Accelerometer__Sequence * lhs, const rcss3d_agent_msgs__msg__Accelerometer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Accelerometer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Accelerometer__Sequence__copy(
  const rcss3d_agent_msgs__msg__Accelerometer__Sequence * input,
  rcss3d_agent_msgs__msg__Accelerometer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__Accelerometer);
    rcss3d_agent_msgs__msg__Accelerometer * data =
      (rcss3d_agent_msgs__msg__Accelerometer *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__Accelerometer__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__Accelerometer__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Accelerometer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
