// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/Effector.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/effector__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `hinge_joint_vels`
#include "rcss3d_agent_msgs/msg/detail/hinge_joint_vel__functions.h"
// Member `universal_joint_vels`
#include "rcss3d_agent_msgs/msg/detail/universal_joint_vel__functions.h"
// Member `beams`
#include "rcss3d_agent_msgs/msg/detail/beam__functions.h"
// Member `says`
#include "rcss3d_agent_msgs/msg/detail/say__functions.h"

bool
rcss3d_agent_msgs__msg__Effector__init(rcss3d_agent_msgs__msg__Effector * msg)
{
  if (!msg) {
    return false;
  }
  // hinge_joint_vels
  if (!rcss3d_agent_msgs__msg__HingeJointVel__Sequence__init(&msg->hinge_joint_vels, 0)) {
    rcss3d_agent_msgs__msg__Effector__fini(msg);
    return false;
  }
  // universal_joint_vels
  if (!rcss3d_agent_msgs__msg__UniversalJointVel__Sequence__init(&msg->universal_joint_vels, 0)) {
    rcss3d_agent_msgs__msg__Effector__fini(msg);
    return false;
  }
  // beams
  if (!rcss3d_agent_msgs__msg__Beam__Sequence__init(&msg->beams, 0)) {
    rcss3d_agent_msgs__msg__Effector__fini(msg);
    return false;
  }
  // says
  if (!rcss3d_agent_msgs__msg__Say__Sequence__init(&msg->says, 0)) {
    rcss3d_agent_msgs__msg__Effector__fini(msg);
    return false;
  }
  return true;
}

void
rcss3d_agent_msgs__msg__Effector__fini(rcss3d_agent_msgs__msg__Effector * msg)
{
  if (!msg) {
    return;
  }
  // hinge_joint_vels
  rcss3d_agent_msgs__msg__HingeJointVel__Sequence__fini(&msg->hinge_joint_vels);
  // universal_joint_vels
  rcss3d_agent_msgs__msg__UniversalJointVel__Sequence__fini(&msg->universal_joint_vels);
  // beams
  rcss3d_agent_msgs__msg__Beam__Sequence__fini(&msg->beams);
  // says
  rcss3d_agent_msgs__msg__Say__Sequence__fini(&msg->says);
}

bool
rcss3d_agent_msgs__msg__Effector__are_equal(const rcss3d_agent_msgs__msg__Effector * lhs, const rcss3d_agent_msgs__msg__Effector * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // hinge_joint_vels
  if (!rcss3d_agent_msgs__msg__HingeJointVel__Sequence__are_equal(
      &(lhs->hinge_joint_vels), &(rhs->hinge_joint_vels)))
  {
    return false;
  }
  // universal_joint_vels
  if (!rcss3d_agent_msgs__msg__UniversalJointVel__Sequence__are_equal(
      &(lhs->universal_joint_vels), &(rhs->universal_joint_vels)))
  {
    return false;
  }
  // beams
  if (!rcss3d_agent_msgs__msg__Beam__Sequence__are_equal(
      &(lhs->beams), &(rhs->beams)))
  {
    return false;
  }
  // says
  if (!rcss3d_agent_msgs__msg__Say__Sequence__are_equal(
      &(lhs->says), &(rhs->says)))
  {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Effector__copy(
  const rcss3d_agent_msgs__msg__Effector * input,
  rcss3d_agent_msgs__msg__Effector * output)
{
  if (!input || !output) {
    return false;
  }
  // hinge_joint_vels
  if (!rcss3d_agent_msgs__msg__HingeJointVel__Sequence__copy(
      &(input->hinge_joint_vels), &(output->hinge_joint_vels)))
  {
    return false;
  }
  // universal_joint_vels
  if (!rcss3d_agent_msgs__msg__UniversalJointVel__Sequence__copy(
      &(input->universal_joint_vels), &(output->universal_joint_vels)))
  {
    return false;
  }
  // beams
  if (!rcss3d_agent_msgs__msg__Beam__Sequence__copy(
      &(input->beams), &(output->beams)))
  {
    return false;
  }
  // says
  if (!rcss3d_agent_msgs__msg__Say__Sequence__copy(
      &(input->says), &(output->says)))
  {
    return false;
  }
  return true;
}

rcss3d_agent_msgs__msg__Effector *
rcss3d_agent_msgs__msg__Effector__create()
{
  rcss3d_agent_msgs__msg__Effector * msg = (rcss3d_agent_msgs__msg__Effector *)malloc(sizeof(rcss3d_agent_msgs__msg__Effector));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__Effector));
  bool success = rcss3d_agent_msgs__msg__Effector__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__Effector__destroy(rcss3d_agent_msgs__msg__Effector * msg)
{
  if (msg) {
    rcss3d_agent_msgs__msg__Effector__fini(msg);
  }
  free(msg);
}


bool
rcss3d_agent_msgs__msg__Effector__Sequence__init(rcss3d_agent_msgs__msg__Effector__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcss3d_agent_msgs__msg__Effector * data = NULL;
  if (size) {
    data = (rcss3d_agent_msgs__msg__Effector *)calloc(size, sizeof(rcss3d_agent_msgs__msg__Effector));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__Effector__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__Effector__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__Effector__Sequence__fini(rcss3d_agent_msgs__msg__Effector__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__Effector__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__Effector__Sequence *
rcss3d_agent_msgs__msg__Effector__Sequence__create(size_t size)
{
  rcss3d_agent_msgs__msg__Effector__Sequence * array = (rcss3d_agent_msgs__msg__Effector__Sequence *)malloc(sizeof(rcss3d_agent_msgs__msg__Effector__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__Effector__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__Effector__Sequence__destroy(rcss3d_agent_msgs__msg__Effector__Sequence * array)
{
  if (array) {
    rcss3d_agent_msgs__msg__Effector__Sequence__fini(array);
  }
  free(array);
}

bool
rcss3d_agent_msgs__msg__Effector__Sequence__are_equal(const rcss3d_agent_msgs__msg__Effector__Sequence * lhs, const rcss3d_agent_msgs__msg__Effector__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Effector__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Effector__Sequence__copy(
  const rcss3d_agent_msgs__msg__Effector__Sequence * input,
  rcss3d_agent_msgs__msg__Effector__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__Effector);
    rcss3d_agent_msgs__msg__Effector * data =
      (rcss3d_agent_msgs__msg__Effector *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__Effector__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__Effector__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Effector__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
