// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/FieldLine.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/field_line__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `start`
// Member `end`
#include "rcss3d_agent_msgs/msg/detail/spherical__functions.h"

bool
rcss3d_agent_msgs__msg__FieldLine__init(rcss3d_agent_msgs__msg__FieldLine * msg)
{
  if (!msg) {
    return false;
  }
  // start
  if (!rcss3d_agent_msgs__msg__Spherical__init(&msg->start)) {
    rcss3d_agent_msgs__msg__FieldLine__fini(msg);
    return false;
  }
  // end
  if (!rcss3d_agent_msgs__msg__Spherical__init(&msg->end)) {
    rcss3d_agent_msgs__msg__FieldLine__fini(msg);
    return false;
  }
  return true;
}

void
rcss3d_agent_msgs__msg__FieldLine__fini(rcss3d_agent_msgs__msg__FieldLine * msg)
{
  if (!msg) {
    return;
  }
  // start
  rcss3d_agent_msgs__msg__Spherical__fini(&msg->start);
  // end
  rcss3d_agent_msgs__msg__Spherical__fini(&msg->end);
}

bool
rcss3d_agent_msgs__msg__FieldLine__are_equal(const rcss3d_agent_msgs__msg__FieldLine * lhs, const rcss3d_agent_msgs__msg__FieldLine * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // start
  if (!rcss3d_agent_msgs__msg__Spherical__are_equal(
      &(lhs->start), &(rhs->start)))
  {
    return false;
  }
  // end
  if (!rcss3d_agent_msgs__msg__Spherical__are_equal(
      &(lhs->end), &(rhs->end)))
  {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__FieldLine__copy(
  const rcss3d_agent_msgs__msg__FieldLine * input,
  rcss3d_agent_msgs__msg__FieldLine * output)
{
  if (!input || !output) {
    return false;
  }
  // start
  if (!rcss3d_agent_msgs__msg__Spherical__copy(
      &(input->start), &(output->start)))
  {
    return false;
  }
  // end
  if (!rcss3d_agent_msgs__msg__Spherical__copy(
      &(input->end), &(output->end)))
  {
    return false;
  }
  return true;
}

rcss3d_agent_msgs__msg__FieldLine *
rcss3d_agent_msgs__msg__FieldLine__create()
{
  rcss3d_agent_msgs__msg__FieldLine * msg = (rcss3d_agent_msgs__msg__FieldLine *)malloc(sizeof(rcss3d_agent_msgs__msg__FieldLine));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__FieldLine));
  bool success = rcss3d_agent_msgs__msg__FieldLine__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__FieldLine__destroy(rcss3d_agent_msgs__msg__FieldLine * msg)
{
  if (msg) {
    rcss3d_agent_msgs__msg__FieldLine__fini(msg);
  }
  free(msg);
}


bool
rcss3d_agent_msgs__msg__FieldLine__Sequence__init(rcss3d_agent_msgs__msg__FieldLine__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcss3d_agent_msgs__msg__FieldLine * data = NULL;
  if (size) {
    data = (rcss3d_agent_msgs__msg__FieldLine *)calloc(size, sizeof(rcss3d_agent_msgs__msg__FieldLine));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__FieldLine__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__FieldLine__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__FieldLine__Sequence__fini(rcss3d_agent_msgs__msg__FieldLine__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__FieldLine__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__FieldLine__Sequence *
rcss3d_agent_msgs__msg__FieldLine__Sequence__create(size_t size)
{
  rcss3d_agent_msgs__msg__FieldLine__Sequence * array = (rcss3d_agent_msgs__msg__FieldLine__Sequence *)malloc(sizeof(rcss3d_agent_msgs__msg__FieldLine__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__FieldLine__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__FieldLine__Sequence__destroy(rcss3d_agent_msgs__msg__FieldLine__Sequence * array)
{
  if (array) {
    rcss3d_agent_msgs__msg__FieldLine__Sequence__fini(array);
  }
  free(array);
}

bool
rcss3d_agent_msgs__msg__FieldLine__Sequence__are_equal(const rcss3d_agent_msgs__msg__FieldLine__Sequence * lhs, const rcss3d_agent_msgs__msg__FieldLine__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__FieldLine__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__FieldLine__Sequence__copy(
  const rcss3d_agent_msgs__msg__FieldLine__Sequence * input,
  rcss3d_agent_msgs__msg__FieldLine__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__FieldLine);
    rcss3d_agent_msgs__msg__FieldLine * data =
      (rcss3d_agent_msgs__msg__FieldLine *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__FieldLine__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__FieldLine__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__FieldLine__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
